import { PermissionFlagsBits, SlashCommandBuilder } from 'discord.js';
import EcoController from '../controller/EcoController';
import { Command } from '.';


// const adminPermissions = new PermissionsBitField('Administrator');

export default {
  data: new SlashCommandBuilder()
    .setName('alert')
    .setDescription('Alert to game')
    .addStringOption(opt => opt.setName("message").setDescription("Alert message").setRequired(true))
    .setDefaultMemberPermissions(PermissionFlagsBits.Administrator),
  async execute(interaction) {
    const ecoController = new EcoController()

    const message = interaction.options.getString('message')

    await interaction.deferReply({ ephemeral: true })

    try {
      if (!message) {
        await interaction.followUp(`Ошибка отправки уведомления`);
        return
      }

      const status = await ecoController.Alert(message)
      if (!!status && !status.Errored) {
        await interaction.followUp("Уведомление отправлено")
      } else {
        await interaction.followUp("Ошибка отправки уведомления")
      }
      return
    } catch (error) {
      await interaction.followUp("Ошибка отправки уведомления")
      console.log(error)
    }
  },
} as Command
