import { CacheType, ChatInputCommandInteraction, Message, PermissionFlagsBits, SlashCommandBuilder } from 'discord.js';
import ConfigController from '../controller/ConfigController';
import EcoController from '../controller/EcoController';
import { Command } from '.';

export default {
  data: new SlashCommandBuilder()
    .setName('msg')
    .setDescription('Message to game')
    .setDescriptionLocalization("ru", "Отправка сообщения в игровой чат")
    .addStringOption(opt => opt.setName("message").setDescription("Message").setDescriptionLocalization("ru", "Сообщение").setRequired(true)),
  async execute(interaction) {
    const ecoController = new EcoController()

    const user = global.config.users.get(interaction.user.id)

    var message = interaction.options.getString('message')

    await interaction.deferReply({ ephemeral: true })

    try {
      if (user !== undefined) {
        if (!message) {
          await interaction.followUp(`Ошибка отправки сообщения`);
          return
        }

        const status = await ecoController.Message(message, user.Name, `#${global.config.inGameChat}`)
        if (!!status && status.Success) {
          await interaction.followUp("Сообщение отправлено")
        } else {
          await interaction.followUp("Ошибка отправки сообщения")
        }
        return
      } else {
        await interaction.followUp("Необходимо сначала связать аккаунты, для этого воспользуйтесь командой `/link`")
      }
    } catch (error) {
      await interaction.editReply("Ошибка отправки сообщения")
      console.log(error)
    }
  },
} as Command